﻿Public Class Form1

  Dim d As Integer = 40
  Dim charactercode As Integer = 0
  Dim first, last As Integer

  Private Sub PictureBox1_MouseEnter(ByVal sender As Object, ByVal e As System.EventArgs) Handles PictureBox1.MouseEnter
    Form2.Show()
    Me.Focus()
  End Sub

  Private Sub PictureBox1_MouseLeave(ByVal sender As Object, ByVal e As System.EventArgs) Handles PictureBox1.MouseLeave
    Form2.Hide()
  End Sub

  Private Sub PictureBox1_MouseMove(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles PictureBox1.MouseMove
    charactercode = first + ((e.Y \ d) << 4) + e.X \ d
    Dim p As Point = Me.Location
    Form2.Location = e.Location + p + New Point(30, 90)
    If charactercode > last Then charactercode = 0
    Form2.Label1.Text = "H" & Hex(charactercode)
  End Sub

  Private Sub PictureBox1_Paint(ByVal sender As Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles PictureBox1.Paint
    Dim code As Int64
    Dim fnt As New System.Drawing.Font("Times New Roman", 24)
    Dim m As Integer = (last - first) \ 16
    For y As Integer = 0 To m
      For x As Integer = 0 To 15
        code = first + (y << 4) + x
        e.Graphics.DrawString(ChrW(code), fnt, Brushes.Black, x * d, y * d)
      Next
    Next
  End Sub

  Private Sub PictureBox1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PictureBox1.Click
    Dim P As Integer = TextBox1.SelectionStart
    TextBox1.Text = TextBox1.Text.Insert(P, ChrW(charactercode))
    TextBox1.Select(P + 1, 0)
    UpdateClipboard()
  End Sub

  Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
    TextBox1.Text = ""
  End Sub

  Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
    TextBox1.Text = Clipboard.GetText
    ComboBox1.SelectedIndex = 0
  End Sub

  Private Sub TextBox1_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBox1.TextChanged
    UpdateClipboard()
  End Sub

  Private Sub UpdateClipboard()
    If TextBox1.Text = "" Then
      Clipboard.Clear()
    Else
      Clipboard.SetText(TextBox1.Text)
    End If
  End Sub

  Private Sub ComboBox1_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ComboBox1.SelectedIndexChanged
    Dim text As String = ComboBox1.Text
    Dim i As Integer = text.IndexOf("-")
    first = Val("&H" & text)
    last = Val("&H" & text.Substring(i + 1))
    PictureBox1.Invalidate()
  End Sub
End Class
